  MEMBER

   Include('SQLFunctions.inc'),ONCE


  Map
  End

LOCINIFileName		String(256),Static 
XMLFile  File,Driver('ASCII'),Name(LOCINIFileName),Pre(XML)
Record     RECORD
DataLine     String(1024)
           End
         END

!==============================================================

SQLFunctions.Construct          Procedure

   Code


!==============================================================

SQLFunctions.Destruct           Procedure

   Code


!==============================================================

SQLFunctions.GetServerName	Procedure(String pServerName)	!,Byte
LOC:ConnectionString	String(256)
SAV:ErrorCode		Byte
Pos1    		Long
Pos2    		Long 
SQLServer		String(40)

	Code

 LOCINIFileName = pServername
 If ~EXISTS(pServerName)        ! check shpDB.XML actually findable
    MESSAGE('Cannot find shpDB.XML, containing SQL connection information.'&|
   '||Application will be terminated.', |
   'Error', ICON:Hand)
   Return 2     ! LOC:ConnectionString
 End
 
 Open(XMLFile)
 SAV:ErrorCode = ErrorCode()
 If ErrorCode()       ! can't open shpDB.XML (for reason other than non-existance)
    MESSAGE('Cannot open shpDB.XML, containing SQL connection information.'&|
   '|Errorcode ' & ErrorCode() & ': ' & Error() &| 
   '||Application will be terminated.', |
   'Error', ICON:Hand)
   Close(XMLFile)
   Return SAV:ErrorCode     ! LOC:ConnectionString
 End 
 Set(XMLFile)           ! read file
 LOOP
   Next(XMLFile)
   If ErrorCode()
     Break
   End
   If Instring('SERVERINSTANCE',Upper(XML:DataLine),1,1)    ! find <ServerInstance> tag
     Pos1 = Instring('>',XML:DataLine,1,1)
     Pos2 = Instring('<',XML:DataLine,1,Pos1)
     SQLServer = XML:DataLine[Pos1+1 : Pos2-1]
     Break
   End
 End 
 Close(XMLFile)
   
 If ~SQLServer    ! couldn't read ServerName
   MESSAGE('Could not read Server Instance from shpDB.XML.'&|
   '||Application will be terminated.', |
   'Error', ICON:Hand)
   Return 1  ! LOC:ConnectionString
 End

!==============================================================

SQLFunctions.GetConnectString  Procedure() !,String
	! returns connection string on success
	! blank string on failure

LOC:ConnectionString	String(256)
SQLServer		String(40)
SQLDatabase          	STRING('SouthBreeze {8}')

       Code

 Clear(LOC:ConnectionString)
 LOCINIFileName = 'C:\Program Files\CMag\shpDB.XML'   ! set NAME()
 If Self.GetServerName(LOCINIFileName) = Level:Benign
   LOC:ConnectionString = Clip(SQLServer) & '; ' & Clip(SQLDataBase) & '; TRUSTED_CONNECTION=Yes;' 
 End

 RETURN LOC:ConnectionString

!==============================================================
SQLFunctions.GetConnectString  Procedure(*String pConnectStr) !,Byte
	! returns 0 (Level:Benign) on success
	! ErrorCode() on failure

LOC:ConnectionString	String(256)
Pos1    		Long
Pos2    		Long 
RetVal			Byte
SQLServer		String(40)
SQLDatabase          	STRING('SouthBreeze {8}')

       Code

 Clear(LOC:ConnectionString)
 LOCINIFileName = 'C:\Program Files\CMag\shpDB.XML'   ! set NAME()
 RetVal = Self.GetServerName(LOCINIFileName)
 If RetVal = 0
   
   ! check for required substring: If ~Instring('SQLEXPRESS',Upper(SQLServer),1,1) 

   LOC:ConnectionString = Clip(SQLServer) & '; ' & Clip(SQLDataBase) & '; TRUSTED_CONNECTION=Yes;'
   pConnectStr = LOC:ConnectionString

   RETURN Level:Benign  ! LOC:ConnectionString
 Else
   Return RetVal
 End

!==============================================================
